1 REM ***************** BAYESIAN BACKWARD CHAINING *******************
10 REM INSTALL YOUR IF CLAUSES IN SEQUENCE AT LOCATIONS 1500,1520,..,1540
20 REM FORMAT EXAMPLE 1500 IF (A1=2) AND (A2=6) OR (A3$="YES") THEN S=1
22 REM                1502 RETURN
30 REM                1520 IF (J$="NO") THEN S=1
32 REM                1522 RETURN
40 REM  THE THEN PART OF THE ABOVE CONSTRUCTION ALWAYS CONTAINS, THEN S=1
50 REM INSTALL YOUR THEN CLAUSES IN SEQUENCE IN STATEMENTS 1510,1530,..,1550
60 REM FORMAT EXAMPLE 1510 PO="YES"..FOLOWED BY A RETURN STATEMENT
200 REM ************ INITIALIZATION SECTION *************
210 REM CONCLUSION LIST (GL$), VARIABLE LIST (V$), INSTANTIATED LIST (IN)
220 REM CONCLUSION STACK INCLUDES STATEMENT STACK (SS) AND CLAUSE STACK (CS)
230 REM  CLAUSE VARIABLE LIST (CV$) AND STACK POINTER (SP)
240 DIM GL$(10),V$(10),CV$(40),IN(10),SS(10),CS(10)
250 SP=11 :REM STACK SPACE IS 10 WE INITIALLY PLACE SP AT 10+1
260 FOR I=1 TO 10
270 GL$(I)="": V$(I)="": IN(I)=0: SS(I)=0: CS(I)=0
280 NEXT I
290 REM ENTER CONCLUSIONS WHICH ARE THE VARIABLES IN THE THEN PART, 1 AT A TIME
295 REM ENTER THE CONCLUSIONS IN EXACT ORDER STARTING AT THE 1ST IF-THEN.
300 REM AFTER LAST CONCLUSION JUST HIT RETURN KEY FOR REST OF CONCLUSIONS
305 GL$(1)="ST":GL$(2)="ST":GL$(3)="IN":GL$(4)="IN"
307 PRINT"*** CONCLUSION LIST ***"
310 FOR I=1 TO 10
320 PRINT"CONCLUSION ";I;
325 PRINT GL$(I)
335 NEXT I
338 INPUT"HIT RETURN TO CONTINUE";Z
340 REM ENTER VARIABLES WHICH ARE IN THE IF PART, 1 AT A TIME IN THE
350 REM EXACT ORDER THAT THEY OCCUR. UP TO 3 VARIABLES PER IF STATEMENT.
360 REM DO NOT DUPLICATE ANY VARIABLES NAMES. ANY NAME IS USED ONLY ONCE
365 REM IF NO MORE VARIABLES LEFT, JUST HIT RETURN KEY.
366 PRINT"*** VARIABLE LIST ***"
367 V$(1)="DO"
370 FOR I=1 TO 10
380 PRINT"VARIABLE ";I;
385 PRINT V$(I)
395 NEXT I
396 INPUT"HIT RETURN TO CONTINUE";I
400 REM ENTER VARIABLES AS THE APPEAR IN THE IF CLAUSES. A MAXIMUM OF 3
405 REM VARIABLES PER IF STATEMENT. IF NO MORE VARIABLES HIT RETURN KEY
406 PRINT"*** CLAUSE-VARIABLE LIST ***"
407 CV$(1)="IN":CV$(5)="IN":CV$(9)="DO":CV$(13)="DO"
410 FOR I=1 TO 8:PRINT"** CLAUSE ";I
420 FOR J=1 TO 4:PRINT"VARIABLE ";J;
423 K=4*(I-1)+J
424 PRINT CV$(K)
430 NEXT J
432 IF I=4 THEN INPUT"HIT RETURN TO CONTINUE";Z
435 NEXT I
500 REM *********************** INFERENCE SECTION **************************
505 INPUT"** ENTER THE CONCLUSION ";V$
510 REM GET CONCLUSION STATEMENT NUMBER (SN) FROM THE CONCLUSION LIST (GL$)
520 F=1:GOSUB 2200: REM 1ST STATEMENT STARTS SEARCH
525 IF SN=0 THEN STOP: REM NO CONCLUSION OF THAT NAME
530 REM PUSH STATEMENT NUMBER (SN) AND CLAUSE NUMBER=1 ON GOAL STACK WHICH
535 REM  IS COMPOSED OF THE STATEMENT STACK (SS) AND CLAUSE STACK (CS)
540 GOSUB 2000
545 REM CALCULATE CLAUSE LOCATION IN CLAUSE-VARIABLE LIST
550 I=(SS(SP)-1)*4+CS(SP)
555 V$=CV$(I): REM CLAUSE VARIABLE
560 REM IS THIS THE LAST CLAUSE FOR THIS STATEMENT?
565 IF V$="" THEN GOTO 580 :REM LAST CLAUSE PROCESS IF-THEN STATEMENT
567 REM IS THIS CLAUSE VARIABLE A CONCLUSION?
568 F=1:GOSUB 2200:IF SN<>0 THEN GOTO 520 :IT IS A CONCLUSION PUSH IT
570 GOSUB 2400: REM CHECK INSTANTIATION OF THIS CLAUSE
575 CS(SP)=CS(SP)+1: GOTO 545 : REM CHECK NEXT CLAUSE
580 REM NO MORE CLAUSES CHECK IF PART OF STATEMENT
582 SN=SS(SP)
585 S=0: ON SN GOSUB 1500,1520,1540,1560,1580,1600
590 REM SEE IF THE THEN PART SHOULD BE INVOKED I.E. S=1
600 IF S=1 THEN GOTO 630 :REM INVOKE THEN PART
605 REM FAILED..SEARCH REST OF STATEMENTS FOR THE SAME CONCLUSION
610 I=SS(SP): V$=GL$(I): REM GET CONCLUSION
615 F=SS(SP)+1 :REM SEARCH FOR CONCLUSION STARTING AT THE NEXT STATEMENT NUMBER
620 GOSUB 2200
625 SP=SP+1:GOTO 525:REM POP OLD CONCLUSION AND PUT ON NEW ONE
630 REM IF PART TRUE INVOKE THE THEN PART
635 ON SN GOSUB 1510,1530,1550,1570,1590,1610
650 REM POP THE STACK..IF IT REACHED THE INITIAL POINT WE HAD OUR SUCCESS
655 REM  IF NOT JUST KEEP GOING TO VERIFY THE OLD CONCLUSION
660 SP=SP+1:REM POP THE STACK
670 IF SP < 11 THEN GOTO 690 :REM STACK IS NOT EMPTY
680 PRINT"*** SUCCESS": REM FINISHED
685 STOP
690 REM STACK NOT EMPTY GET NEXT CLAUSE THEN CONTINUE
695 CS(SP)=CS(SP)+1
700 GOTO 545
1490 REM ********** IF-THEN STATEMENT STARTING AT 1500 *******************
1492 REM SAMPLE IF-THEN STATEMENTS FROM THE POSITION KNOWLEDGE BASE
1494 REM  ONLY THE FIRST TWO LETTERS OF EACH VARIABLE IS USED TO MAKE
1496 REM  THE EXAMPLE COMPATIBLE WITH SOME VERSIONS OF BASIC. FOR EXAMPLE
1498 REM DEG WAS SHORTENED TO DE AND QUAL TO QU
1499 REM ** STATEMENT 1
1500 IF IN$="FALL" THEN S=1
1502 RETURN
1510 I2=1-I1:PRINT"P(INTEREST=NOT FALL)=";I2
1512 INPUT"WHAT IS THE PROBABILITY OF STOCKS RISING IF INTEREST RATES FALL";S4
1514 INPUT"WHAT IS THE PROBABILITY OF STOCKS RISING IF INTEREST RATES DO NOT FALL";S5
1516 S1=S4*I1+S5*I2:PRINT"P(STOCK=RISE)=";S1
1518 ST$="RISE":PRINT"ST=RISE":RETURN
1519 REM ** STATEMENT 2
1520 IF IN$="RISE" THEN S=1
1522 RETURN
1530 I2=1-I1:PRINT"P(INTEREST=NOT RISE)=";I2
1532 INPUT"WHAT IS THE PROBABILITY OF STOCKS FALLING IF INTEREST RATES RISE";S4
1534 INPUT"WHAT IS THE PROBABILITY OF STOCKS FALLING IF INTEREST RATES DO NOT RISE";S5
1536 S1=S4*I1+S5*I2:PRINT"P(STOCK=FALL)="S1
1538 ST$="FALL":PRINT"ST=FALL" :RETURN
1539 REM ** STATEMENT 3
1540 IF DO$="FALL" THEN S=1
1542 RETURN
1550 INPUT"WHAT IS THE PROBABILITY OF THE VALUE OF THE DOLLAR FALLING";I1
1552 I2=1-I1:PRINT"P(DOLLAR=NOT FALL)=";I2
1554 INPUT"WHAT IS THE PROBABILITY OF INTEREST RATES RISING IF THE DOLLAR FALLS";S4
1556 INPUT"WHAT IS THE PROBABILITY OF INTEREST RATES RISING IF THE DOLLAR DOES NOT FALL";S5
1558 S1=S4*I1+S5*I2:PRINT"P(INTEREST=RISE)=";S1:I1=S1:IN$="RISE":PRINT"IN=RISE:RETURN
1559 REM ** STATEMENT 4
1560 IF DO$="RISE" THEN S=1
1562 RETURN
1570 INPUT"WHAT IS THE PROBABILITY OF THE VALUE OF THE DOLLAR RISING";I1
1572 I2=1-I1:PRINT"P(DOLLAR=NOT RISE)=";I2
1574 INPUT"WHAT IS THE PROBABILITY OF INTEREST RATES FALLING IF THE DOLLAR RISES";S4
1576 INPUT"WHAT IS THE PROBABILITY OF INTEREST RATES FALLING IF THE DOLLAR DOES NOT RISE";S5
1578 S1=S4*I1+S5*I2:PRINT"P(INTEREST=FALL)=";S1:I1=S1:IN$="FALL":PRINT"IN=FALL":RETURN
1611 REM ****** END OF POSITION KNOWLEDGE BASE ***********
1690 REM ********** INPUT STATEMENTS STARTING AT 1700 ********************
1699 REM **** INPUT STATEMENTS FOR SAMPLE POSITION KNOWLEDGE BASE
1700 INPUT"IS THE DOLLAR EXPECTED TO RISE OR FALL";DO$ :RETURN
1750 REM ****** END OF INPUT STATEMENTS FOR THE POSITION KNOWLEDGE BASE **
1999 REM ******************** SUBROUTINE SECTION ***************************
2000 REM ROUTINE TO PUSH STATEMENT NUMBER (SN) AND A CLAUSE NUMBER OF 1
2002 REM  ONTO THE CONCLUSION STACK WHICH CONSISTS OF THE STATEMENT STACK (SS)
2004 REM  AND THE CLAUSE STACK (CS).....TO PUSH DECREMENT STACK POINTER (SP)
2020 SP=SP-1: SS(SP)=SN: CS(SP)=1
2030 RETURN
2099 REM ********************************************************************
2200 REM ROUTINE TO DETERMINE IF A VARIABLE (V$) IS A MEMBER OF THE CONCLUSION LIST
2202 REM  (GL$). IF YES RETURN SN<>0. IF NOT A MEMBER SN=0.
2220 SN=0:REM INITIALLY SET TO NOT A MEMBER
2230 FOR I=F TO 8 :REM MEMBER OF CONCLUSION LIST TO BE SEARCHED IS F
2240 IF V$= GL$(I) THEN GOTO 2270: REM TEST FOR MEMBERSHIP
2250 NEXT I
2260 RETURN: REM NOT A MEMBER
2270 SN=I:REM A MEMBER
2280 RETURN
2299 REM ********************************************************************
2400 REM ROUTINE TO INSTANTIATE A VARIABLE (V$) IF IT ISN'T ALREADY. THE
2402 REM  INSTANTIATE INDICATION (IN) IS A 0 IF NOT, A 1 IF IT IS. THE
2404 REM  VARIABLE LIST (VL$) CONTAINS THE VARIABLE (V$)
2420 FOR I=1 TO 10: REM FIND VARIABLE IN THE LIST
2430 IF V$=V$(I) THEN GOTO 2445: REM FOUND VARIABLE IN LIST
2440 NEXT I
2445 IF IN(I)=1 THEN RETURN: REM ALREADY INSTANTIATED
2450 IF IN(I)=1 THEN RETURN: REM ALREADY INSTANTIATED
2460 REM THE DESIGNER OF THIS KNOWLEDGE BASE PLACES THE INPUT STATEMENTS
2462 REM  TO INSTANTIATE THE VARIABLES STARTING AT LOCATION 1700
2464 REM FORMAT IS INPUT STATEMENT FOLLOWED BY A RETURN STATEMENT
2465 IN(I)=1:REM MARK INSTANTIATED
2470 ON I GOSUB 1700,1705,1710,1715
2480 RETURN
